// VUE生命周期函数
export var VUE_LIFECYCLE_HOOKS = ['onMounted', 'onUpdated', 'onUnmounted', 'onBeforeMount', 'onBeforeUpdate', 'onBeforeUnmount', 'onErrorCaptured', 'onRenderTracked', 'onRenderTriggered', 'onActivated', 'onDeactivated', 'onServerPrefetch'];
// vue chunk 名称
export var VUE_CHUNK_NAME = {
  ScriptStart: 'VueComponentScriptStart',
  ScriptVueImp: 'VueComponentScriptVueImp',
  ScriptInitState: 'VueComponentScriptInitState',
  ScriptMockApi: 'VueComponentScriptMockApi',
  ScriptLifeCycles: 'VueComponentScriptLifeCycles',
  ScriptMethods: 'VueComponentScriptMethods',
  ScriptContent: 'VueComponentScriptContent',
  ScriptEnd: 'VueComponentScriptEnd',
  TemplateStart: 'VueComponentTemplateStart',
  TemplateContent: 'VueComponentTemplateContent',
  TemplateEnd: 'VueComponentTemplateEnd',
  StyleStart: 'VueComponentStyleStart',
  StyleContent: 'VueComponentStyleContent',
  StyleEnd: 'VueComponentStyleEnd'
};
// vue chunk 序列，多个chunk生成同一个文件时，按照此顺序自上而下插入不同chunk的内容
export var VUE_CHUNK_SEQUENCE = [VUE_CHUNK_NAME.ScriptStart, VUE_CHUNK_NAME.ScriptVueImp, VUE_CHUNK_NAME.ScriptInitState, VUE_CHUNK_NAME.ScriptMockApi, VUE_CHUNK_NAME.ScriptLifeCycles, VUE_CHUNK_NAME.ScriptMethods, VUE_CHUNK_NAME.ScriptContent, VUE_CHUNK_NAME.ScriptEnd, VUE_CHUNK_NAME.TemplateStart, VUE_CHUNK_NAME.TemplateContent, VUE_CHUNK_NAME.TemplateEnd, VUE_CHUNK_NAME.StyleStart, VUE_CHUNK_NAME.StyleContent, VUE_CHUNK_NAME.StyleEnd];

// 返回当前chunk前面的chunk
export var linkAfter = function linkAfter(chunk) {
  var curIndex = VUE_CHUNK_SEQUENCE.indexOf(chunk);
  var afters = VUE_CHUNK_SEQUENCE.slice(0, curIndex);
  return afters;
};