import CodeGen from '@alilc/lowcode-code-generator';
import { isLiteralAtomicExpr } from '../util/isLiteralAtomicExpr';
import { isSimpleStraightLiteral } from '../util/isSimpleStraightLiteral';
import { transformThis2Context } from './transformThis2Context';
var parseExpression = CodeGen.utils.expressionParser.parseExpression;
export function transformJsExpr(expr, scope, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    _ref$dontWrapEval = _ref.dontWrapEval,
    dontWrapEval = _ref$dontWrapEval === void 0 ? false : _ref$dontWrapEval,
    _ref$dontTransformThi = _ref.dontTransformThis2ContextAtRootScope,
    dontTransformThis2ContextAtRootScope = _ref$dontTransformThi === void 0 ? false : _ref$dontTransformThi;
  if (!expr) {
    return 'undefined';
  }
  if (isLiteralAtomicExpr(expr)) {
    return expr;
  }
  var exprAst = parseExpression(expr);

  // 对于下面这些比较安全的字面值，可以直接返回对应的表达式，而非包一层
  if (isSimpleStraightLiteral(exprAst)) {
    return expr;
  }
  if (dontWrapEval) {
    return transformThis2Context(exprAst, scope, {
      ignoreRootScope: dontTransformThis2ContextAtRootScope
    });
  }
  switch (exprAst.type) {
    // 对于直接写个函数的，则不用再包下，因为这样不会抛出异常的
    case 'ArrowFunctionExpression':
    case 'FunctionExpression':
      return transformThis2Context(exprAst, scope, {
        ignoreRootScope: dontTransformThis2ContextAtRootScope
      });
    default:
      break;
  }

  // 其他的都需要包一层
  return "__$$eval(() => (" + transformThis2Context(exprAst, scope, {
    ignoreRootScope: dontTransformThis2ContextAtRootScope
  }) + "))";
}