import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import CodeGen, { COMMON_CHUNK_NAME, ChunkType, FileType } from '@alilc/lowcode-code-generator';
var buildDataSourceDependencies = CodeGen.utils.dataSource.buildDataSourceDependencies;
var pluginFactory = function pluginFactory(cfg) {
  var plugin = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(pre) {
      var next, ir, packages, packageJson;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            next = _extends({}, pre);
            ir = next.ir;
            packages = ir.packages;
            packages.forEach(function (pkg) {
              if (pkg["package"] === 'ElementPlus') {
                pkg["package"] = 'element-plus';
              }
            });
            packageJson = {
              name: (cfg === null || cfg === void 0 ? void 0 : cfg.packageName) || 'vue3-demo-app',
              version: (cfg === null || cfg === void 0 ? void 0 : cfg.packageVersion) || '0.0.0',
              description: '浪潮软件低代码平台',
              dependencies: _extends({
                vue: '^3.3.4',
                'vue-router': '^4.2.4'
              }, buildDataSourceDependencies(ir, cfg === null || cfg === void 0 ? void 0 : cfg.datasourceConfig)),
              devDependencies: {
                '@rushstack/eslint-patch': '^1.3.2',
                '@vitejs/plugin-vue': '^4.2.3',
                '@vue/eslint-config-prettier': '^8.0.0',
                eslint: '^8.45.0',
                'eslint-plugin-vue': '^9.15.1',
                prettier: '^3.0.0',
                vite: '^4.4.6'
              },
              scripts: {
                dev: 'vite',
                build: 'vite build',
                preview: 'vite preview',
                lint: 'eslint . --ext .vue,.js,.jsx,.cjs,.mjs --fix --ignore-path .gitignore',
                format: 'prettier --write src/'
              },
              "private": true
            };
            ir.packages.forEach(function (packageInfo) {
              packageJson.dependencies[packageInfo["package"]] = packageInfo.version;
            });
            next.chunks.push({
              type: ChunkType.JSON,
              fileType: FileType.JSON,
              name: COMMON_CHUNK_NAME.FileMainContent,
              content: packageJson,
              linkAfter: []
            });
            return _context.abrupt("return", next);
          case 8:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function plugin(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  return plugin;
};
export default pluginFactory;