import _extends from "@babel/runtime/helpers/extends";
import prettier from 'prettier';
import parserBabel from 'prettier/parser-babel';
import parserPostCss from 'prettier/parser-postcss';
import parserVue from 'prettier-plugin-vue';
import parserHtml from 'prettier/parser-html';
var PARSERS = ['css', 'scss', 'less', 'json', 'html', 'vue'];
var factory = function factory(config) {
  var cfg = _extends({
    customFileTypeParser: {}
  }, config);
  var codePrettier = function codePrettier(content, fileType) {
    var parser;
    if (fileType === 'js' || fileType === 'jsx' || fileType === 'ts' || fileType === 'tsx') {
      parser = 'babel-ts';
    } else if (fileType === 'vue') {
      parser = 'vue';
    } else if (fileType === 'json') {
      parser = 'json-stringify';
    } else if (PARSERS.indexOf(fileType) >= 0) {
      parser = fileType;
    } else if (cfg.customFileTypeParser[fileType]) {
      parser = cfg.customFileTypeParser[fileType];
    } else {
      return content;
    }
    return prettier.format(content, {
      parser: parser,
      plugins: [parserBabel, parserPostCss, parserVue, parserHtml].concat(cfg.plugins || []),
      singleQuote: true,
      jsxSingleQuote: false,
      htmlWhitespaceSensitivity: 'ignore',
      jsxBracketSameLine: false,
      vueIndentScriptAndStyle: false
    });
  };
  return codePrettier;
};
export default factory;