import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { Base64 } from 'js-base64';
import workerJson from '../../public/standalone-worker.json';
export var DEFAULT_WORKER_JS = './dist/standalone-worker.js';
export var DEFAULT_TIMEOUT_IN_MS = 60 * 1000;
var workerJsCache = new Map();
export function init(_x) {
  return _init.apply(this, arguments);
}
function _init() {
  _init = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_temp) {
    var _ref, _ref$workerJsUrl, workerJsUrl;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _ref = _temp === void 0 ? {} : _temp, _ref$workerJsUrl = _ref.workerJsUrl, workerJsUrl = _ref$workerJsUrl === void 0 ? DEFAULT_WORKER_JS : _ref$workerJsUrl;
          _context.next = 3;
          return loadWorkerJs(workerJsUrl);
        case 3:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return _init.apply(this, arguments);
}
export function generateCode(_x2) {
  return _generateCode.apply(this, arguments);
}
function _generateCode() {
  _generateCode = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(options) {
    var workerJsUrl, workerJs, worker;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          if (!(typeof self !== 'object')) {
            _context2.next = 2;
            break;
          }
          throw new Error('self is not defined');
        case 2:
          if (!(typeof Worker !== 'function')) {
            _context2.next = 4;
            break;
          }
          throw new Error('Worker is not supported');
        case 4:
          workerJsUrl = options.workerJsUrl || DEFAULT_WORKER_JS;
          _context2.next = 7;
          return loadWorkerJs(workerJsUrl);
        case 7:
          workerJs = _context2.sent;
          worker = new Worker(workerJs.url, {
            type: 'classic',
            credentials: 'omit'
          });
          return _context2.abrupt("return", new Promise(function (resolve, reject) {
            var timer = setTimeout(function () {
              reject(new Error('timeout'));
              worker.terminate();
            }, options.timeoutInMs || DEFAULT_TIMEOUT_IN_MS);
            worker.onmessage = function (event) {
              var msg = event.data;
              switch (msg.type) {
                case 'ready':
                  print('worker is ready.');
                  break;
                case 'run:begin':
                  print('worker is running...');
                  break;
                case 'run:end':
                  print('worker is done.');
                  resolve(msg.result);
                  clearTimeout(timer);
                  worker.terminate();
                  break;
                case 'run:error':
                  printErr("worker error: " + msg.errorMsg);
                  clearTimeout(timer);
                  reject(new Error(msg.errorMsg || 'unknown error'));
                  worker.terminate();
                  break;
                default:
                  print('got unknown msg: %o', msg);
                  break;
              }
            };
            worker.onerror = function (err) {
              printErr('worker error: %o', err);
              clearTimeout(timer);
              reject(err);
              worker.terminate();
            };
            worker.postMessage({
              type: 'run',
              solution: 'vue3',
              schema: options.schema,
              flattenResult: options.flattenResult
            });
          }));
        case 10:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return _generateCode.apply(this, arguments);
}
function loadWorkerJs(_x3) {
  return _loadWorkerJs.apply(this, arguments);
}
function _loadWorkerJs() {
  _loadWorkerJs = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(workerJsUrl) {
    var cached, workerJsContent, workerJs;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          cached = workerJsCache.get(workerJsUrl);
          if (!cached) {
            _context3.next = 3;
            break;
          }
          return _context3.abrupt("return", cached);
        case 3:
          workerJsContent = Base64.decode(workerJson.workerJs);
          workerJs = {
            content: workerJsContent,
            url: self.URL.createObjectURL(new self.Blob([workerJsContent], {
              type: 'application/javascript'
            }))
          };
          workerJsCache.set(workerJsUrl, workerJs);
          return _context3.abrupt("return", workerJs);
        case 7:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return _loadWorkerJs.apply(this, arguments);
}
function print(msg) {
  var _console;
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  // eslint-disable-next-line no-console
  (_console = console).debug.apply(_console, ["[code-generator/loader]: " + msg].concat(args));
}
function printErr(msg) {
  var _console2;
  for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }
  // eslint-disable-next-line no-console
  (_console2 = console).debug.apply(_console2, ["[code-generator/loader]: %c" + msg, 'color:red'].concat(args));
}