import * as constants from './plugins/component/vue3/const';
import * as globalUtils from './utils';
/**
 * 出码插件入口
 *
 * 用于出码插件初始化以及完成各子插槽函数的注册
 *
 * 插槽函数：用于解析schema配置生成特定代码片段。
 *
 * 插槽：用于指定代码片段最终插入的目标位置。
 */
export default function createVueProjectBuilder(): import("@alilc/lowcode-code-generator").IProjectBuilder;
export declare const publishers: {
    disk: import("@alilc/lowcode-code-generator").PublisherFactory<import("@alilc/lowcode-code-generator/types/publisher/disk").IDiskFactoryParams, import("@alilc/lowcode-code-generator/types/publisher/disk").IDiskPublisher>;
    zip: import("@alilc/lowcode-code-generator").PublisherFactory<import("@alilc/lowcode-code-generator/types/publisher/zip").ZipFactoryParams, import("@alilc/lowcode-code-generator/types/publisher/zip").ZipPublisher>;
};
export declare const plugins: {
    methods: import("@alilc/lowcode-code-generator").BuilderComponentPluginFactory<import("./plugins/component/vue3/methods").PluginConfig>;
    vue: import("@alilc/lowcode-code-generator").BuilderComponentPluginFactory<import("./plugins/component/vue3/vue").PluginConfig>;
    styles: import("@alilc/lowcode-code-generator").BuilderComponentPluginFactory<import("./plugins/component/vue3/styles").PluginConfig>;
    constants: typeof constants;
    globalUtils: typeof globalUtils;
};
