"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.linkAfter = exports.VUE_CHUNK_SEQUENCE = exports.VUE_CHUNK_NAME = exports.VUE_LIFECYCLE_HOOKS = void 0;
// VUE生命周期函数
exports.VUE_LIFECYCLE_HOOKS = [
    'onMounted',
    'onUpdated',
    'onUnmounted',
    'onBeforeMount',
    'onBeforeUpdate',
    'onBeforeUnmount',
    'onErrorCaptured',
    'onRenderTracked',
    'onRenderTriggered',
    'onActivated',
    'onDeactivated',
    'onServerPrefetch',
];
// vue chunk 名称
exports.VUE_CHUNK_NAME = {
    ScriptStart: 'VueComponentScriptStart',
    ScriptVueImp: 'VueComponentScriptVueImp',
    ScriptInitState: 'VueComponentScriptInitState',
    ScriptMockApi: 'VueComponentScriptMockApi',
    ScriptLifeCycles: 'VueComponentScriptLifeCycles',
    ScriptMethods: 'VueComponentScriptMethods',
    ScriptContent: 'VueComponentScriptContent',
    ScriptEnd: 'VueComponentScriptEnd',
    TemplateStart: 'VueComponentTemplateStart',
    TemplateContent: 'VueComponentTemplateContent',
    TemplateEnd: 'VueComponentTemplateEnd',
    StyleStart: 'VueComponentStyleStart',
    StyleContent: 'VueComponentStyleContent',
    StyleEnd: 'VueComponentStyleEnd',
};
// vue chunk 序列，多个chunk生成同一个文件时，按照此顺序自上而下插入不同chunk的内容
exports.VUE_CHUNK_SEQUENCE = [
    exports.VUE_CHUNK_NAME.ScriptStart,
    exports.VUE_CHUNK_NAME.ScriptVueImp,
    exports.VUE_CHUNK_NAME.ScriptInitState,
    exports.VUE_CHUNK_NAME.ScriptMockApi,
    exports.VUE_CHUNK_NAME.ScriptLifeCycles,
    exports.VUE_CHUNK_NAME.ScriptMethods,
    exports.VUE_CHUNK_NAME.ScriptContent,
    exports.VUE_CHUNK_NAME.ScriptEnd,
    exports.VUE_CHUNK_NAME.TemplateStart,
    exports.VUE_CHUNK_NAME.TemplateContent,
    exports.VUE_CHUNK_NAME.TemplateEnd,
    exports.VUE_CHUNK_NAME.StyleStart,
    exports.VUE_CHUNK_NAME.StyleContent,
    exports.VUE_CHUNK_NAME.StyleEnd,
];
// 返回当前chunk前面的chunk
const linkAfter = (chunk) => {
    const curIndex = exports.VUE_CHUNK_SEQUENCE.indexOf(chunk);
    const afters = exports.VUE_CHUNK_SEQUENCE.slice(0, curIndex);
    return afters;
};
exports.linkAfter = linkAfter;
//# sourceMappingURL=const.js.map