"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const lowcode_code_generator_1 = require("@alilc/lowcode-code-generator");
const const_1 = require("./const");
const pluginFactory = () => {
    const plugin = (pre) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        var _a;
        const next = Object.assign({}, pre);
        const ir = next.ir;
        const { list } = (_a = ir.dataSource) !== null && _a !== void 0 ? _a : { list: [] };
        if (!list.length) {
            return next;
        }
        let apis = '';
        list.forEach((item) => {
            var _a;
            const { options, id } = item;
            const url = (_a = options === null || options === void 0 ? void 0 : options.uri.toString()) !== null && _a !== void 0 ? _a : 'url';
            apis +=
                `'${url}':{
        mock: ${id},
        url:'${url}',
        options:${JSON.stringify(options)},
      },`;
        });
        const mockContent = () => {
            const content = `\n const fetch = async(url,mock=true) => {
        if(mock){
          return Promise.resolve(apis[url].mock).then(res => {
            let data = JSON.parse(JSON.stringify(res.value))
            return data
          })
        }
        const res =await window.fetch(apis[url].url, apis[url].options)
       return res.json();
     };`;
            return `const apis = {${apis}}${content}`;
        };
        next.chunks.push({
            type: lowcode_code_generator_1.ChunkType.STRING,
            fileType: 'vue',
            name: const_1.VUE_CHUNK_NAME.ScriptMockApi,
            content: mockContent(),
            linkAfter: [
                const_1.VUE_CHUNK_NAME.ScriptStart,
                const_1.VUE_CHUNK_NAME.ScriptVueImp,
                const_1.VUE_CHUNK_NAME.ScriptInitState,
            ],
        });
        return next;
    });
    return plugin;
};
exports.default = pluginFactory;
//# sourceMappingURL=mock.js.map