"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const lowcode_code_generator_1 = tslib_1.__importDefault(require("@alilc/lowcode-code-generator"));
const { createResultFile } = lowcode_code_generator_1.default.utils.resultHelper;
function getFile() {
    const file = createResultFile('vite.config', 'js', `
import { fileURLToPath, URL } from 'node:url'

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [
    vue(),
  ],
  resolve: {
    alias: {
      '@': fileURLToPath(new URL('./src', import.meta.url))
    }
  }
})
    
    `);
    return [[], file];
}
exports.default = getFile;
//# sourceMappingURL=vite.config.js.js.map