"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _lowcodeCodeGenerator = _interopRequireWildcard(require("@alilc/lowcode-code-generator"));
var _const = require("./const");
var _transformJsExpression = require("./core/jsx/handlers/transformJsExpression");
var _transformThis2Context = require("./core/jsx/handlers/transformThis2Context");
var _utils = require("../../../utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var _CodeGen$utils = _lowcodeCodeGenerator["default"].utils,
  generateExpression = _CodeGen$utils.jsExpression.generateExpression,
  generateCompositeType = _CodeGen$utils.compositeType.generateCompositeType,
  Scope = _CodeGen$utils.scope.Scope;
var createReactNodeGenerator = _utils.nodeToVue.createReactNodeGenerator;
var pluginFactory = function pluginFactory(config) {
  var cfg = (0, _extends2["default"])({
    fileType: 'vue',
    // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
    nodeTypeMapping: {}
  }, config);
  var nodeTypeMapping = cfg.nodeTypeMapping;
  var plugin = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(pre) {
      var next, _next$contextData$tol, tolerateEvalErrors, customHandlers, generatorPlugins, generator, ir, scope, jsxContent;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            next = (0, _extends2["default"])({}, pre);
            _next$contextData$tol = next.contextData.tolerateEvalErrors, tolerateEvalErrors = _next$contextData$tol === void 0 ? true : _next$contextData$tol; // 这里会将内部的一些子上下文的访问(this.xxx)转换为 __$$context.xxx 的形式
            // 与 Rax 所不同的是，这里不会将最顶层的 this 转换掉
            customHandlers = {
              // eslint-disable-next-line @typescript-eslint/no-shadow
              expression: function expression(input, scope, config) {
                var _config$tolerateEvalE;
                return (0, _transformJsExpression.transformJsExpr)(generateExpression(input, scope), scope, {
                  dontWrapEval: !((_config$tolerateEvalE = config === null || config === void 0 ? void 0 : config.tolerateEvalErrors) !== null && _config$tolerateEvalE !== void 0 ? _config$tolerateEvalE : tolerateEvalErrors),
                  dontTransformThis2ContextAtRootScope: true
                });
              },
              "function": function _function(input, scope) {
                return (0, _transformThis2Context.transformThis2Context)(generateCompositeType({
                  type: 'JSFunction',
                  value: input.value || 'function () {}'
                }, Scope.createRootScope()), scope, {
                  ignoreRootScope: true
                });
              }
            };
            generatorPlugins = {
              handlers: customHandlers,
              tagMapping: function tagMapping(v) {
                return nodeTypeMapping[v] || v;
              },
              tolerateEvalErrors: tolerateEvalErrors
            };
            generator = createReactNodeGenerator(generatorPlugins);
            ir = next.ir;
            scope = Scope.createRootScope();
            jsxContent = generator(ir, scope);
            next.chunks.push({
              type: _lowcodeCodeGenerator.ChunkType.STRING,
              fileType: cfg.fileType,
              name: _const.VUE_CHUNK_NAME.ScriptStart,
              content: '<script setup>',
              linkAfter: []
            });
            next.chunks.push({
              type: _lowcodeCodeGenerator.ChunkType.STRING,
              fileType: cfg.fileType,
              name: _const.VUE_CHUNK_NAME.ScriptContent,
              content: 'console.log("欢迎使用浪潮软件-网页设计器")',
              linkAfter: (0, _const.linkAfter)(_const.VUE_CHUNK_NAME.ScriptContent)
            });
            next.chunks.push({
              type: _lowcodeCodeGenerator.ChunkType.STRING,
              fileType: cfg.fileType,
              name: _const.VUE_CHUNK_NAME.ScriptEnd,
              content: '</script>',
              linkAfter: (0, _const.linkAfter)(_const.VUE_CHUNK_NAME.ScriptEnd)
            });
            next.chunks.push({
              type: _lowcodeCodeGenerator.ChunkType.STRING,
              fileType: cfg.fileType,
              name: _const.VUE_CHUNK_NAME.TemplateStart,
              content: '<template>',
              linkAfter: (0, _const.linkAfter)(_const.VUE_CHUNK_NAME.TemplateStart)
            });
            next.chunks.push({
              type: _lowcodeCodeGenerator.ChunkType.STRING,
              fileType: cfg.fileType,
              name: _const.VUE_CHUNK_NAME.TemplateContent,
              content: jsxContent,
              linkAfter: (0, _const.linkAfter)(_const.VUE_CHUNK_NAME.TemplateContent)
            });
            next.chunks.push({
              type: _lowcodeCodeGenerator.ChunkType.STRING,
              fileType: cfg.fileType,
              name: _const.VUE_CHUNK_NAME.TemplateEnd,
              content: '</template>',
              linkAfter: (0, _const.linkAfter)(_const.VUE_CHUNK_NAME.TemplateEnd)
            });
            next.chunks.push({
              type: _lowcodeCodeGenerator.ChunkType.STRING,
              fileType: cfg.fileType,
              name: _const.VUE_CHUNK_NAME.StyleStart,
              content: '<style scoped>',
              linkAfter: (0, _const.linkAfter)(_const.VUE_CHUNK_NAME.StyleStart)
            });
            next.chunks.push({
              type: _lowcodeCodeGenerator.ChunkType.STRING,
              fileType: cfg.fileType,
              name: _const.VUE_CHUNK_NAME.StyleEnd,
              content: '</style>',
              linkAfter: (0, _const.linkAfter)(_const.VUE_CHUNK_NAME.StyleEnd)
            });
            return _context.abrupt("return", next);
          case 17:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function plugin(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  return plugin;
};
var _default = pluginFactory;
exports["default"] = _default;