"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.generateStaticFiles = generateStaticFiles;
var _lowcodeCodeGenerator = _interopRequireDefault(require("@alilc/lowcode-code-generator"));
var _README = _interopRequireDefault(require("./files/README.md"));
var _viteConfigJs = _interopRequireDefault(require("./files/vite.config.js.js"));
var _gitignore = _interopRequireDefault(require("./files/gitignore"));
var _prettierrc = _interopRequireDefault(require("./files/prettierrc.json"));
var _eslintrc = _interopRequireDefault(require("./files/eslintrc.cjs"));
var _CodeGen$utils = _lowcodeCodeGenerator["default"].utils,
  createResultDir = _CodeGen$utils.resultHelper.createResultDir,
  runFileGenerator = _CodeGen$utils.templateHelper.runFileGenerator;
function generateStaticFiles(root) {
  if (root === void 0) {
    root = createResultDir('.');
  }
  // 创建README.md文件
  runFileGenerator(root, _README["default"]);
  // 创建vite配置文件
  runFileGenerator(root, _viteConfigJs["default"]);
  // 创建gitignore配置文件
  runFileGenerator(root, _gitignore["default"]);
  // 创建prettier配置文件
  runFileGenerator(root, _prettierrc["default"]);
  // 创建eslint配置文件
  runFileGenerator(root, _eslintrc["default"]);
  return root;
}