"use strict";

exports.__esModule = true;
exports.executeFunctionStack = executeFunctionStack;
function executeFunctionStack(input, scope, funcs, baseFunc, config) {
  var funcList = [];
  if (Array.isArray(funcs)) {
    funcList.push.apply(funcList, funcs);
  } else {
    funcList.push(funcs);
  }
  var next = baseFunc;
  var _loop = function _loop() {
    var func = funcList.pop();
    if (func) {
      var warppedFunc = function (nextFunc) {
        return function (i, s, cfg) {
          return func(i, s, cfg, nextFunc);
        };
      }(next);
      next = warppedFunc;
    }
  };
  while (funcList.length > 0) {
    _loop();
  }
  return next(input, scope, config);
}